#open "graphics";;

open_graph " 600x600";;

let arrondi x = 
 let Ex = int_of_float x in
 let Exf = float_of_int Ex in
   if x -. Exf < 0.5 then Ex else Ex+1;;

arrondi 12.52;;

(*   sujet X PSI 2011 *)

(* on dfnit le type image 
	i.H (hauteur), i.L (largeur), i.P (profondeur) et i.M (matrice).
*)
type image = {H : int; L : int; P : int; M : int vect vect};;

let allouer (H,L,P) = {H=H; L=L; P=P; M=make_matrix H L P};;

      
(* lecture de fichier TIFF non compresser (mode "interleave") : il faut 
connaitre les dimensions de l'image, ici on peut lire des images de taille lxh.
Ici les coordonnees RVB de chaque point se succedent.
L'entte comporte 8 octets *)
(* h = hauteur
   l = largeur *)
let lire_RAW_3 l h fichier =
let f = open_in fichier and c = ref 0 in
let image_rouge = make_matrix h l 0 in
let image_vert = make_matrix h l 0 in
let image_bleu = make_matrix h l 0 in
let image_gris = make_matrix h l 0 in
let image = allouer(h,l,256) in
let rouge = ref 0 and vert = ref 0 and bleu = ref 0 and noir = ref 0 in 
try
   let c = ref(0) in
     for i = 1 to 8 do 
         c := int_of_char (input_char f);
		printf__printf "%d\n" !c;
      done;
    for i = 0 to h-1 do
      for j = 0 to l-1 do 
         image_rouge.(i).(j) <- int_of_char (input_char f);
         image_vert.(i).(j) <- int_of_char (input_char f);
         image_bleu.(i).(j) <- int_of_char (input_char f);
         image_gris.(i).(j) <- int_of_char (input_char f);
         image.M.(i).(j) <- image_rouge.(i).(j)
      done;
    done;
    for i = 0 to h-1 do
      for j = 0 to l-1 do 
	     set_color (rgb image_rouge.(i).(j)  image_vert.(i).(j) image_bleu.(i).(j)); 
          plot  (j) (h-i)
      done;
    done;
    close_in f;
    image;
with End_of_file ->
    close_in f;
    failwith "Fin de fichier atteinte\n";;


let chemin = "/Users/Eric/Documents/Enseignement/Devoirs/Devoirs 11-12/";;
clear_graph ();;
let img_A = lire_RAW_3 250 300 (chemin^"XPSI2011_img_A.tiff");;

let affiche img = 
    clear_graph ();
    for l = 0 to img.H - 1 do
      for c = 0 to img.L - 1 do
          let gris = (img.M.(l).(c)*255)/img.P in 
     	     set_color (gris+256*gris+65536*gris); 
               plot c (img.H-l);
      done;
    done;;

affiche img_A;;
              
(* Question 1 *)
let inverser i = 
let image = allouer(i.H,i.L,i.P) in
for l = 0 to i.H-1 do
   printf__printf "l=%d H=%d\n" l i.H;
   for c = 0 to i.L-1 do
      image.M.(l ).(c )<- i.P - (i.M).(l ).(c )
   done;
done;
image;;      

let img_B = inverser img_A;;
affiche img_B;;
affiche (poserH(img_A,img_B));;
        
(* Question 2 *)
let flipH i = 
let image = allouer(i.H,i.L,i.P) in
for c = 0 to i.L-1 do
   for l = 0 to i.H-1 do
      image.M.(l).(c) <- (i.M).(l).(i.L-c-1)
   done;
done;
image;; 

let img_C = flipH img_A;;
affiche img_C;;

affiche (poserH(img_A,img_C));;
        
(* Question 3 *)
let poserV (i1,i2) = 
let image = allouer(i1.H+i2.H,i1.L,i1.P) in
for c = 0 to i1.L-1 do
   for l = 0 to i1.H-1 do
      image.M.(l).(c) <- (i1.M).(l).(c)
   done;
   for l = 0 to i2.H-1 do
      image.M.(l+i1.H).(c) <- (i2.M).(l).(c)
   done;
done;
image;; 

affiche (poserV (img_B,img_C));;      

(* Question 4 *)
let poserH (i1,i2) = 
let image = allouer(i1.H,i1.L+i2.L,i1.P) in
for l = 0 to i1.H-1 do
   for c = 0 to i1.L-1 do
      image.M.(l).(c) <- (i1.M).(l).(c)
   done;
   for c = 0 to i2.L-1 do
      image.M.(l).(c+i1.L ) <- (i2.M).(l).(c )
   done;
done;
image;; 

let img_E =poserH (img_B,img_C);;      
affiche img_E;;

(* Question 5 *)
let transferer (i,P',t)=
let image = allouer(i.H,i.L,P') in
for c = 0 to i.L-1 do
   for l = 0 to i.H-1 do
      image.M.(l).(c) <- t.((i.M).(l).(c))
   done;
done;
image;; 

(* Question 6 *)
let inverser' i = 
let t = make_vect (i.P + 1) 0 in
for k = 0 to i.P do 
   t.(k) <- i.P-k
done;   
transferer (i,i.P,t);;

let image = inverser' img_A;;
affiche image;;
affiche (poserH(img_A,image));;

(* Question 7 *)
let histogramme (i,h) = 
let h = make_vect (i.P+1) 0 in
for c = 0 to i.L-1 do
   for l = 0 to i.H-1 do
      let niveau = (i.M).(l).(c) in
      h.(niveau) <- h.(niveau) + 1
   done;
done;
h;;

let h = make_vect (img_A.P + 1) 0;;
histogramme (img_A,h);;

(* Question 8 *)
let egaliser i =
let h = make_vect (img_A.P + 1) 0 in
let h = histogramme(i,h) in
let v_min = ref 0 in
while h.(!v_min)=0 do incr v_min done;
let v' = make_vect (i.P+1) 0 
    and s = ref 0 in
for v = !v_min to i.P do
    s := !s + h.(v);
    v'.(v) <- i.P*(!s - h.(!v_min))/(i.H*i.L - h.(!v_min))
done;
transferer (i,i.P,v');;        
 
let img_F = egaliser img_A;;
affiche (poserH (img_A,img_F));;

(* Question 9 *)
let Img_blanche = allouer(10,10,16);;
egaliser Img_blanche;;

let h = make_vect (Img_blanche.P + 1) 0;;
let h = histogramme (Img_blanche,h);;
h.(16);;

(* On a un problme de division par 0 *)

(* Question 10 *)
let reduire_bis (i,P') =
let image = allouer(i.H,i.L,P') in
for c = 0 to i.L-1 do
   for l = 0 to i.H-1 do
      let k = (i.M).(l).(c) in
      let k' = (float_of_int (P'*k))/. (float_of_int i.P) in
             image.M.(l).(c) <- arrondi(k')
   done;
done;
image;; 

let reduire (i,P') =
let v' = make_vect (i.P+ 1) 0 in
for k = 0 to i.P do 
   v'.(k) <- arrondi((float_of_int (P'*k))/. (float_of_int i.P));
done;
transferer(i,P',v');; 

let img_G = reduire_bis (img_A,1) ;;
affiche img_G
;;

let img_G = reduire (img_A,1) and img_G' = reduire_bis (img_A,1) in
affiche (poserH(img_G,img_G'));
;;

let img_H = reduire (img_A,4);;
affiche(img_H);;

let img_I = reduire (img_A,16);;
affiche(img_I);;

(* Question 11 *)
let tramer (i,m) =
let image = allouer(i.H,i.L,1) in
let hauteur_motif = m.H in
let largeur_motif = m.L in
for l = 0 to i.H-1 do
   for c = 0 to i.L-1 do
   let seuil = m.M.(l mod hauteur_motif).(c mod largeur_motif) in
      if (i.M).(l).(c) > seuil
          then
            image.M.(l).(c) <- 1
          else
            image.M.(l).(c) <- 0;
   done;
done;
image;; 

let motif = [|[|0|];[|1|];[|2|];[|3|]|];;
let m = {H = 4; L = 1; P = 4; M = motif};;
let img_L = tramer (img_H,m);;
affiche img_L;;

(* Question 12 *)
let tramerTelevision i =
let image = allouer(i.H,i.L,1) in
let n = i.P in
let m = allouer(n,1,0) in
for k = 1 to n-1 do
   m.M.(k).(0) <- k
done;
tramer(i,m);;

let img_L' = tramerTelevision img_H;;	
affiche img_L';;

let img_I' = tramerTelevision img_I;;
affiche img_I';;

let img_A' = tramerTelevision img_A;;
affiche img_A';;

let motif = [|[|1;5;10;14|];[|3;7;8;12|];[|13;9;6;2|];[|15;11;4;0|]|];;

let deuxQuarts = {H=4; L=4;P=15;M=motif};;

affiche deuxQuarts;;
let img1 = poserV (deuxQuarts,flipH deuxQuarts);;
let img2 = poserV (flipH deuxQuarts,deuxQuarts);;
affiche (poserH(img1,img2));;

(* Question 13 *)
let tramerJournal (i) =
let img1 = poserV (deuxQuarts,flipH deuxQuarts) in
let img2 = poserV (flipH deuxQuarts,deuxQuarts) in
let motif = poserH (img1,img2) in
   tramer(i,motif);; 

let img_M =  tramerJournal img_I;;
affiche img_M;;

(* Question 14 *)
let tramerJournal_bis (i) =
let img1 = poserV (deuxQuarts,flipH deuxQuarts) in 
let img2 = poserV (flipH deuxQuarts,deuxQuarts) in
let MotifDiagonal = poserH(img1,img2) in
let image = allouer(2*i.H,2*i.L,i.P) in
for l = 0 to i.H-1 do
   for c = 0 to i.L-1 do
       let nuance = i.M.(l).(c) in
           image.M.(2*l).(2*c) <- nuance;
           image.M.(2*l+1).(2*c) <- nuance;
           image.M.(2*l).(2*c+1) <- nuance;
           image.M.(2*l+1).(2*c+1) <- nuance;
   done;
done;
if i.P = 15 then tramer(image,MotifDiagonal)
else if i.P > 15 then tramer(reduire(image,15),MotifDiagonal)
                 else tramer(image,reduire(MotifDiagonal,i.P));; 

let img_N =  tramerJournal_bis img_I;;
affiche img_N;;

affiche(poserH(img_M,img_N));;





